<script lang="ts" setup>
import { ref } from 'vue';
import Accordion from './../common/Accordion.vue';
import type { BaseLink } from '@/types/base';
import {
  ShieldCheckLargeLight,
  Devsecops,
  LockClose,
  Institution,
  UserGroup,
  User,
  MagnifyingGlass,
  CollaborationAlt4,
} from 'slippers-ui/icons';

const icons = {
  ShieldCheckLargeLight,
  Devsecops,
  LockClose,
  Institution,
  UserGroup,
  User,
  MagnifyingGlass,
  CollaborationAlt4,
};

interface AccordionItem {
  header: string;
  content: string;
  button?: Array<BaseLink>;
}

interface AccordionWrapperProps {
  tagline?: string;
  title: string;
  subtitle?: string;
  description?: string;
  cta?: BaseLink;
  accordion: Array<AccordionItem>;
  config: {
    icon?: string;
    isFullWidth: boolean;
    disableTexture?: boolean;
    id?: string;
    pill?: boolean;
  };
}

defineProps<AccordionWrapperProps>();

const isOpenIndex = ref(0);
const toggleController = (index: number) => {
  isOpenIndex.value = index;
};
</script>

<template>
  <section :id="config?.id" class="accordion-wrapper">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="config?.isFullWidth ? 12 : 6" class="slp-pr-md-32" size="lg">
          <div :class="{ tagline }">
            <SlpIcon v-if="config.icon" :icon="icons[config.icon]" alt="" :size="tagline ? 18 : 32" color="black" />
            <SlpTypography v-if="tagline" variant="body2-bold" tag="p">{{ tagline }}</SlpTypography>
            <img
              v-if="!config?.disableTexture"
              src="/images/css_backgrounds/accordion-flourish.svg"
              alt=""
              class="slp-pl-8"
            />
          </div>
          <SlpTypography tag="h2" variant="heading2-bold" class="slp-py-16">{{ title }}</SlpTypography>
          <SlpTypography v-if="subtitle" tag="p" variant="heading5" class="subtitle slp-mr-md-48 slp-mb-16">{{
            subtitle
          }}</SlpTypography>
          <SlpTypography v-if="description" tag="p" variant="body1" class="description slp-mr-md-48 slp-mb-16">{{
            description
          }}</SlpTypography>
          <SlpButton
            v-if="cta"
            variant="primary"
            class="cta"
            :href="cta.config.href"
            :data-ga-name="cta.config.dataGaName"
            :data-ga-location="cta.config.dataGaLocation"
          >
            {{ cta.text }}
          </SlpButton>
        </SlpColumn>
        <SlpColumn :cols="config?.isFullWidth ? 12 : 6" class="slp-pl-md-16" size="lg">
          <Accordion
            v-for="(item, index) in accordion"
            :key="item.header"
            :data="item"
            :is-open="isOpenIndex == index"
            @toggle-controller="toggleController(index)"
          />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.accordion-wrapper {
  padding: $spacing-96 0;
  .slp-icon {
    vertical-align: baseline;
  }

  @media (max-width: $breakpoint-sm) {
    padding: $spacing-48 0;
    .subtitle,
    .description {
      margin-bottom: $spacing-16;
    }
  }

  .subtitle,
  .description {
    margin-right: 48px;

    @media (max-width: $breakpoint-md) {
      margin-right: 0px;
    }
  }

  .description {
    color: $color-text-200;
  }

  .accordion {
    border-top: 1px solid $color-surface-300;

    :deep(.accordion__content-container) {
      padding: 12px $spacing-24 $spacing-24 0;
      .content {
        color: $color-text-200;
      }
    }
  }

  :deep(.accordion__summary) {
    padding: $spacing-16 0;
    font-weight: 660;
    font-size: 24px;
  }
}
.tagline {
  display: flex;
  padding: 4px 12px;
  width: fit-content;
  align-items: center;
  gap: 8px;
  border-radius: 20px;
  position: relative;
  background-clip: padding-box;
  border: solid 1.5px transparent;
  background: white;
  &:before {
    content: '';
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    z-index: -1;
    margin: -2px;
    border-radius: inherit;
    background: linear-gradient(to right, #e1986d, #7759c2, #6e43d3);
  }
}
.cta {
  margin-bottom: $spacing-32;
}
</style>
